﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Matrix;
using Matrix.Xmpp.Client;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace MatriXSamples
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class ChatWindow : Page
    {
        XmppClient client;
        Contact currentFriend;

        public ChatWindow()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            var friend = e.Parameter as ChatFriendData;
            this.client = friend.Client;
            this.currentFriend = friend.Contact;
            
            client.Dispatcher = this.Dispatcher;
            client.MessageFilter.Add(this.currentFriend.Id, new BareJidComparer(), MessageCallback);
            txtChatPane.Text = "";
        }

        private void MessageCallback(object sender, MessageEventArgs e)
        {
            txtChatPane.Text += e.Message.Body + "\n";
        }

        private void txtEnterChat_KeyDown(object sender, KeyRoutedEventArgs e)
        {
            if (e.Key == Windows.System.VirtualKey.Enter)
            {
                client.Send(new Message { To = currentFriend.Id, Body = txtEnterChat.Text, Type = Matrix.Xmpp.MessageType.chat });
                txtEnterChat.Text = "";
            }
        }
    }
}
